<template>
  <el-form ref="userInfor" :model="userInfor" label-width="120px">
    <el-form-item
      label="Account"
      prop="name"
      :rules="[
        {
          required: true,
          message: 'Account is required',
          trigger: 'blur',
        },
        {
          max: 25,
          message: 'Password is more than 25 characters !',
          trigger: 'blur',
        },
      ]"
    >
      <el-input v-model="userInfor.name" :maxlength="25"></el-input>
    </el-form-item>
    <el-form-item label="Full name">
      <el-input v-model="userInfor.full_name"></el-input>
    </el-form-item>
    <el-form-item
      v-if="!this.$route.params.id"
      label="Password"
      prop="password"
      :rules="[
        { required: true, message: 'Password is required', trigger: 'blur' },
        {
          min: 8,
          message: 'Password is more than 8 characters !',
          trigger: 'blur',
        },
      ]"
    >
      <el-input type="password" v-model="userInfor.password"></el-input>
    </el-form-item>
    <el-form-item
      label="Email"
      prop="email"
      :rules="[
        {
          required: true,
          message: 'Please input email address',
          trigger: 'blur',
        },
        {
          type: 'email',
          message: 'Please input correct email address',
          trigger: ['blur', 'change'],
        },
      ]"
    >
      <el-input v-model="userInfor.email"></el-input>
    </el-form-item>
    <el-form-item
      label="Phone"
      prop="phone"
      :rules="[
        {
          min: 6,
          max: 13,
          message: 'Phone is more than 6 and less than 13 characters !',
          trigger: 'blur',
        },
      ]"
    >
      <el-input v-model="userInfor.phone" :maxlength="13"></el-input>
    </el-form-item>
    <el-form-item label="Sex">
      <template>
        <el-radio border v-model="userInfor.sex" label="0">Male</el-radio>
        <el-radio border v-model="userInfor.sex" label="1">Female</el-radio>
      </template>
    </el-form-item>
    <el-form-item label="Address">
      <el-input v-model="userInfor.address"></el-input>
    </el-form-item>
    <el-form-item label="Status">
      <template>
        <el-radio border v-model="userInfor.status" label="1">Process</el-radio>
        <el-radio border v-model="userInfor.status" label="0"
          >Unprocess</el-radio
        >
      </template>
    </el-form-item>
    <el-form-item>
      <el-button type="primary" @click="onSubmit('userInfor')">Save</el-button>
      <el-button @click="goBack()">Cancel</el-button>
    </el-form-item>
  </el-form>
</template>

<script>
import axios from "axios";
import { BASE_URL } from "~/constants/constants.js";

export default {
  name: "CreateEditPage",
  data() {
    return {
      userInfor: {
        name: "",
        email: "",
        full_name: "",
        phone: "",
        sex: "0",
        address: "",
        status: "1",
        password: "",
      },
      radio: "0",
    };
  },
  mounted() {
    this.getList();
  },

  methods: {
    /**
     *  Update, Create user by id
     */
    onSubmit(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
        // Update user
          if (this.$route.params.id) {
            axios
              .put(`${BASE_URL}/update/${this.$route.params.id}`, this.userInfor)
              .then(() => {
                this.$swal.fire({
                  position: "top-end",
                  icon: "success",
                  title: "Edit user successful !",
                  showConfirmButton: false,
                  timer: 1500,
                });
                this.$router.push("/users");
              })
              .catch(() => {
                this.$swal.fire({
                  position: "top-end",
                  icon: "error",
                  title: "Server error!",
                  showConfirmButton: false,
                  timer: 1500,
                });
              });
          } else {
            // Create user
            axios
              .post(`${BASE_URL}/store`, this.userInfor)
              .then(() => {
                this.userInfor = {};
                this.$swal.fire({
                  position: "top-end",
                  icon: "success",
                  title: "Create user successful !",
                  showConfirmButton: false,
                  timer: 1500,
                });
                this.$router.push("/users");
              })
              .catch(() => {
                this.$swal.fire({
                  position: "top-end",
                  icon: "error",
                  title: "Server error!",
                  showConfirmButton: false,
                  timer: 1500,
                });
              });
          }
        } else {
          this.$swal.fire({
            title: "Submit false !",
            showClass: {
              popup: "animate__animated animate__fadeInDown",
            },
            hideClass: {
              popup: "animate__animated animate__fadeOutUp",
            },
          });
        }
      });
    },
    /**
     *  Get list user by id
     *  @param id
     */
    getList() {
      if (this.$route.params.id) {
        axios
          .get(`${BASE_URL}/show/${this.$route.params.id}`)
          .then((response) => {
            this.userInfor = response.data.data;
          });
      }
    },

    /**
     * Cancel form
     */
    goBack() {
      this.$router.go(-1);
    },
  },
};
</script>

<style>
.el-form-item {
  font-size: 18px !important;
  font-weight: 600;
}
</style>
